import Cookies from 'js-cookie';

const TokenKey = `${process.env.VUE_APP_COOKIES_PREFIX}token`;


export function getToken() {
  return Cookies.get('id');
}

export function setToken(token) {
  return Cookies.set(TokenKey, token);
}


export function removeToken() {
  return Cookies.remove(TokenKey);
}

export function getCookie(key) {
  return Cookies.get(process.env.VUE_APP_COOKIES_PREFIX + key);
}

export function getCookieByKey(key) {
  return Cookies.get(key);
}

export function setCookie(key, val) {
  return Cookies.set(process.env.VUE_APP_COOKIES_PREFIX + key, val);
}

export function removeCookie(key) {
  return Cookies.remove(process.env.VUE_APP_COOKIES_PREFIX + key);
}

export function removeCookieByKey(key) {
  return Cookies.remove(key);
}
