import Vue from 'vue';
import Router from 'vue-router';
import Home from './views/Home.vue';
import Overview from './views/Overview.vue';
import TrafficHistory from './views/TrafficHistory.vue';
import TrafficRemind from './views/TrafficRemind.vue';
import UserManagement from './views/userManagement/UserManagement.vue';

Vue.use(Router);

export default new Router({
  mode: 'history',
  // base: process.env.BASE_URL,
  scrollBehavior(to, from, savedPosition) {
    return { x: 0, y: 0 };
  },
  routes: [
    {
      path: '/',
      name: 'home',
      component: Home,
      meta: {
        requireAuth: true,
      },
      children: [{
        path: '/overview',
        name: 'overview',
        component: Overview,
      },
      {
        path: '/trafficHistory',
        name: 'trafficHistory',
        component: TrafficHistory,
      },
      {
        path: '/trafficRemind',
        name: 'trafficRemind',
        component: TrafficRemind,
      },
      {
        path: '/userManagement',
        name: 'userManagement',
        component: UserManagement,
      },

      ],
    },
    // 注册页面
    {
      path: '/registered',
      name: 'registered',
      component: () => import(/* webpackChunkName: "about" */ './views/Registered.vue'),
    },
    // 登录页面
    {
      path: '/login',
      name: 'login',
      component: () => import(/* webpackChunkName: "about" */ './views/Login.vue'),
    },
  ],
});
